"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import asset_pb2
import builtins
import google.protobuf.descriptor
import google.protobuf.message
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class escrow_rejected(google.protobuf.message.Message):
    """Related to escrow_approve_operation and escrow_transfer_operation.
    Generated when pending escrow transfer is cancelled and user that initiated it receives all the funds back.
    It can happen with explicit rejection with use of first operation. Can also happen during block processing when either
    agent or to account failed to approve before ratification deadline.
    @see escrow_approved
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FROM_ACCOUNT_FIELD_NUMBER: builtins.int
    TO_ACCOUNT_FIELD_NUMBER: builtins.int
    AGENT_FIELD_NUMBER: builtins.int
    ESCROW_ID_FIELD_NUMBER: builtins.int
    HBD_AMOUNT_FIELD_NUMBER: builtins.int
    HIVE_AMOUNT_FIELD_NUMBER: builtins.int
    FEE_FIELD_NUMBER: builtins.int
    from_account: builtins.str
    """@param {string} from_account - user that initiated escrow transfer (receiver of all the funds)"""
    to_account: builtins.str
    """@param {string} to_account - user that was target of cancelled escrow transfer"""
    agent: builtins.str
    """@param {string} agent - user that was designated as agent of cancelled escrow transfer"""
    escrow_id: builtins.int
    """@param {number} escrow_id - id of cancelled escrow transfer"""
    @property
    def hbd_amount(self) -> asset_pb2.asset:
        """@param {asset} hbd_amount - (HBD) funds from cancelled escrow transfer (same amount as in escrow_transfer_operation)"""
    @property
    def hive_amount(self) -> asset_pb2.asset:
        """@param {asset} hive_amount - (HIVE) funds from cancelled escrow transfer (same amount as in escrow_transfer_operation)"""
    @property
    def fee(self) -> asset_pb2.asset:
        """@param {asset} fee - (HIVE of HBD) fee from cancelled escrow transfer (same amount as in escrow_transfer_operation)"""
    def __init__(
        self,
        *,
        from_account: builtins.str | None = ...,
        to_account: builtins.str | None = ...,
        agent: builtins.str | None = ...,
        escrow_id: builtins.int | None = ...,
        hbd_amount: asset_pb2.asset | None = ...,
        hive_amount: asset_pb2.asset | None = ...,
        fee: asset_pb2.asset | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["agent", b"agent", "escrow_id", b"escrow_id", "fee", b"fee", "from_account", b"from_account", "hbd_amount", b"hbd_amount", "hive_amount", b"hive_amount", "to_account", b"to_account"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["agent", b"agent", "escrow_id", b"escrow_id", "fee", b"fee", "from_account", b"from_account", "hbd_amount", b"hbd_amount", "hive_amount", b"hive_amount", "to_account", b"to_account"]) -> None: ...

global___escrow_rejected = escrow_rejected
